import { FillMode } from './FillMode';
import { FillColorStop } from './FillColorStop';
export declare class Fill {
    mode: FillMode;
    x0?: string | number | undefined;
    y0?: string | number | undefined;
    x1?: string | number | undefined;
    y1?: string | number | undefined;
    radius?: string | number | undefined;
    colorStops?: string[] | FillColorStop[] | undefined;
    constructor(mode: FillMode, x0?: string | number | undefined, y0?: string | number | undefined, x1?: string | number | undefined, y1?: string | number | undefined, radius?: string | number | undefined, colorStops?: string[] | FillColorStop[] | undefined);
    static solid(color: string): Fill;
    static linear(x0: number | string, y0: number | string, x1: number | string, y1: number | string, colorStops: FillColorStop[] | string[]): Fill;
    static horizontal(colorStops: FillColorStop[] | string[]): Fill;
    static vertical(colorStops: FillColorStop[] | string[]): Fill;
    static radial(x: number | string, y: number | string, radius: number | string, colorStops: FillColorStop[] | string[]): Fill;
    toMap(): Record<string, any>;
}
